## libfm-qt 0.10.0+20151214

=== CMakeLists.txt ===
set(libfm_TRANSLATION_TEMPLATE ${PROJECT_NAME})

include_directories(
    "${LIBFM_INCLUDE_DIRS}"
    "${LIBFM_INCLUDEDIR}/libfm" # to workaround incorrect #include in fm-actions.
    "${LIBMENUCACHE_INCLUDE_DIRS}"
    "${SYSTEM_LIBS_INCLUDE_DIRS}"
)

link_directories(
    "${LIBFM_LIBRARY_DIRS}"
    "${LIBMENUCACHE_LIBRARY_DIRS}"
    "${SYSTEM_LIBS_LIBRARY_DIRS}"
)

set(libfm_SRCS
    libfmqt.cpp
    bookmarkaction.cpp
    sidepane.cpp
    icontheme.cpp
    filelauncher.cpp
    foldermodel.cpp
    foldermodelitem.cpp
    cachedfoldermodel.cpp
    proxyfoldermodel.cpp
    folderview.cpp
    folderitemdelegate.cpp
    createnewmenu.cpp
    filemenu.cpp
    foldermenu.cpp
    filepropsdialog.cpp
    applaunchcontext.cpp
    placesview.cpp
    placesmodel.cpp
    placesmodelitem.cpp
    dirtreeview.cpp
    dirtreemodel.cpp
    dirtreemodelitem.cpp
    dnddest.cpp
    mountoperation.cpp
    mountoperationpassworddialog.cpp
    mountoperationquestiondialog.cpp
    fileoperation.cpp
    fileoperationdialog.cpp
    renamedialog.cpp
    pathedit.cpp
    colorbutton.cpp
    fontbutton.cpp
    browsehistory.cpp
    utilities.cpp
    dndactionmenu.cpp
    editbookmarksdialog.cpp
    thumbnailloader.cpp
    path.cpp
    execfiledialog.cpp
    appchoosercombobox.cpp
    appmenuview.cpp
    appchooserdialog.cpp
    filesearchdialog.cpp
    fm-search.c # might be moved to libfm later
)

set(libfm_UIS
    file-props.ui
    file-operation-dialog.ui
    rename-dialog.ui
    mount-operation-password.ui
    edit-bookmarks.ui
    exec-file.ui
    app-chooser-dialog.ui
    filesearch.ui
)

qt5_wrap_ui(libfm_UIS_H ${libfm_UIS})

# add translation for libfm-qt
lxqt_translate_ts(QM_FILES
    UPDATE_TRANSLATIONS ${UPDATE_TRANSLATIONS}
    SOURCES ${libfm_SRCS} ${libfm_UIS}
    TEMPLATE ${libfm_TRANSLATION_TEMPLATE}
)

add_library(${LIBFM_QT_LIBRARY_NAME} SHARED
    ${libfm_SRCS}
    ${libfm_UIS_H}
    ${QM_FILES}
)

set_property(
    TARGET ${LIBFM_QT_LIBRARY_NAME} APPEND
    PROPERTY COMPILE_DEFINITIONS
    LIBFM_DATA_DIR="${CMAKE_INSTALL_FULL_DATADIR}/libfm-qt"
)

# only turn on custom actions support if it is enabled in libfm.
if(EXISTS "${LIBFM_INCLUDEDIR}/libfm/fm-actions.h")
    set_property(TARGET ${LIBFM_QT_LIBRARY_NAME} APPEND PROPERTY COMPILE_DEFINITIONS CUSTOM_ACTIONS)
endif()

install(EXPORT
    "${LIBFM_QT_LIBRARY_NAME}-targets"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${LIBFM_QT_LIBRARY_NAME}"
    COMPONENT Devel
)

target_link_libraries(${LIBFM_QT_LIBRARY_NAME}
    Qt5::Widgets
    Qt5::X11Extras
    ${LIBFM_LIBRARIES}
    ${LIBMENUCACHE_LIBRARIES}
    ${SYSTEM_LIBS_LIBRARIES}
)

# set libtool soname
set_target_properties(${LIBFM_QT_LIBRARY_NAME} PROPERTIES
    VERSION ${LIBFM_QT_LIB_VERSION}
    SOVERSION ${LIBFM_QT_LIB_SOVERSION}
)

target_include_directories(${LIBFM_QT_LIBRARY_NAME}
    INTERFACE "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/${LIBFM_QT_LIBRARY_NAME}_export.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/libfm-qt"
    COMPONENT Devel
)

# install include header files (FIXME: can we make this cleaner? should dir name be versioned?)
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/libfm-qt"
    COMPONENT Devel
    FILES_MATCHING PATTERN "*.h"
)

generate_export_header(${LIBFM_QT_LIBRARY_NAME}
    EXPORT_MACRO_NAME LIBFM_QT_API
)

configure_package_config_file(
    "${PROJECT_SOURCE_DIR}/cmake/fm-qt-config.cmake.in"
    "${PROJECT_BINARY_DIR}/install/${LIBFM_QT_LIBRARY_NAME}-config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${LIBFM_QT_LIBRARY_NAME}"
)

install(FILES
    "${PROJECT_BINARY_DIR}/install/${LIBFM_QT_LIBRARY_NAME}-config.cmake"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${LIBFM_QT_LIBRARY_NAME}"
    COMPONENT Devel
)

# FIXME: add libtool version to the lib (soname) later.
# FIXME: only export public symbols

install(TARGETS ${LIBFM_QT_LIBRARY_NAME}
    DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    EXPORT "${LIBFM_QT_LIBRARY_NAME}-targets"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    PUBLIC_HEADER
    COMPONENT Runtime
)

export(TARGETS ${LIBFM_QT_LIBRARY_NAME}
    FILE "${CMAKE_BINARY_DIR}/${LIBFM_QT_LIBRARY_NAME}-targets.cmake"
    EXPORT_LINK_INTERFACE_LIBRARIES
)

# install a pkgconfig file for libfm-qt
set(REQUIRED_QT "Qt5Widgets >= ${REQUIRED_QT_VERSION} Qt5X11Extras >= ${REQUIRED_QT_VERSION}")
configure_file(libfm-qt.pc.in lib${LIBFM_QT_LIBRARY_NAME}.pc @ONLY)
# FreeBSD loves to install files to different locations
# http://www.freebsd.org/doc/handbook/dirstructure.html
if(${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
    install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/lib${LIBFM_QT_LIBRARY_NAME}.pc"
        DESTINATION libdata/pkgconfig
        COMPONENT Devel
    )
else()
    install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/lib${LIBFM_QT_LIBRARY_NAME}.pc"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
        COMPONENT Devel
    )
endif()

install(FILES
    ${QM_FILES}
    DESTINATION "${CMAKE_INSTALL_DATADIR}/libfm-qt/translations"
    COMPONENT Runtime
)

# prevent the generated files from being deleted during make cleaner
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM true)

=== debian/changelog ===
libfm-qt (0.10.0+20151214-2) unstable; urgency=medium

  [ Alf Gaida ]
  * Dropped debug package, using the new -dbgsym
  * Added initial arch-bits 32/64 in symbols

  [ ChangZhuo Chen (陳昌倬) ]
  * Update Vcs-* fields.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 07 Feb 2016 15:37:40 +0800

libfm-qt (0.10.0+20151214-1) unstable; urgency=medium

  [ Alf Gaida ]
  * forked pcmanfm-qt debian/$foo 
  * Imported upstream version 0.10.0+20151214.
  * Initial release (Closes: #808192)

  [ ChangZhuo Chen (陳昌倬) ]
  * Add Breaks for old library name libfm-qt5-2.

 -- Alf Gaida <agaida@siduction.org>  Thu, 05 Nov 2015 00:28:39 +0100

=== debian/control ===
Source: libfm-qt
Maintainer: LXQt Packaging Team <pkg-lxqt-devel@lists.alioth.debian.org>
Uploaders: Alf Gaida <agaida@siduction.org>,
           ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
           Andrew Lee (李健秋) <ajqlee@debian.org>,
           Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>
Section: x11
Priority: optional
Build-Depends: cmake (>= 3.0.2),
               debhelper (>= 9),
               libfm-dev (>= 1.2.0),
               libglib2.0-dev,
               liblxqt0-dev (>= 0.10.0),
               libmenu-cache-dev,
               libqt5x11extras5-dev,
               libqt5xdg-dev (>= 1.3.0),
               libx11-dev,
               pkg-config,
               qttools5-dev,
               qttools5-dev-tools
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-lxqt/libfm-qt
Vcs-Git: https://anonscm.debian.org/pkg-lxqt/libfm-qt.git -b debian/sid
Homepage: https://github.com/lxde/libfm-qt

Package: libfm-qt2
Replaces: libfm-qt5-2
Breaks: libfm-qt5-2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: file management support for pcmanfm-qt
 Libfm-Qt is a companion library providing components to build desktop file
 managers.
 .
 This package contains helper library libfm-qt for pcmanfm-qt.

Package: libfm-qt-dev
Replaces: libfm-qt5-dev
Breaks: libfm-qt5-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libfm-qt2 (= ${binary:Version})
Description: file management support library for pcmanfm-qt (development files)
 This package contains development files for helper library libfm-qt.

=== debian/rules ===
#!/usr/bin/make -f
#DH_VERBOSE = 1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh ${@} --buildsystem cmake --parallel

=== debian/watch ===
version=3
opts="pgpsigurlmangle=s/$/.asc/" \
    https://github.com/lxde/libfm-qt/releases .*/([\d\.]+).tar.gz

## libfm-qt 0.11.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(libfm-qt)

set(LIBFM_QT_LIBRARY_NAME "fm-qt" CACHE STRING "fm-qt")

set(LIBFM_QT_VERSION_MAJOR 0)
set(LIBFM_QT_VERSION_MINOR 11)
set(LIBFM_QT_VERSION_PATCH 0)
set(LIBFM_QT_VERSION ${LIBFM_QT_VERSION_MAJOR}.${LIBFM_QT_VERSION_MINOR}.${LIBFM_QT_VERSION_PATCH})

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

# We use the libtool versioning scheme for the internal so name, "current:revision:age"
# http://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html#Updating-version-info
# https://www.sourceware.org/autobook/autobook/autobook_91.html
# http://pusling.com/blog/?p=352
# Actually, libtool uses different ways on different operating systems. So there is no
# universal way to translate a libtool version-info to a cmake version.
# We use "(current-age).age.revision" as the cmake version.
# current: 3, revision: 0, age: 0 => version: 3.0.0
set(LIBFM_QT_LIB_VERSION "3.0.0")
set(LIBFM_QT_LIB_SOVERSION "3")

set(REQUIRED_QT_VERSION "5.2")
set(REQUIRED_LIBFM_VERSION "1.2.0")
set(REQUIRED_LIBMENUCACHE_VERSION "0.4.0")

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

find_package(Qt5Widgets "${REQUIRED_QT_VERSION}" REQUIRED)
find_package(Qt5LinguistTools "${REQUIRED_QT_VERSION}" REQUIRED)
find_package(Qt5X11Extras "${REQUIRED_QT_VERSION}" REQUIRED)

find_package(PkgConfig)
pkg_check_modules(SYSTEM_LIBS REQUIRED
    glib-2.0
    gio-2.0
    gio-unix-2.0
    xcb
)

pkg_check_modules(LIBFM REQUIRED libfm>="${REQUIRED_LIBFM_VERSION}")
pkg_check_modules(LIBMENUCACHE REQUIRED libmenu-cache>="${REQUIRED_LIBMENUCACHE_VERSION}")

option(UPDATE_TRANSLATIONS "Update source translation translations/*.ts files" OFF)
include(GNUInstallDirs)
include(GenerateExportHeader)
include(CMakePackageConfigHelpers)
include(LXQtTranslateTs)
include(LXQtTranslateDesktop)

add_definitions(-DQT_NO_KEYWORDS)

# set visibility to hidden to hide symbols, unless they're exported manually in the code
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

if (CMAKE_VERSION VERSION_LESS "3.1")
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
    if(COMPILER_SUPPORTS_CXX11)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    else()
        CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
        # -std=c++0x is deprecated but some tools e.g. qmake or older gcc are still using it
        if(COMPILER_SUPPORTS_CXX0X)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
        else()
            message(FATAL_ERROR "Compiler ${CMAKE_CXX_COMPILER} does not support c++11/c++0x")
        endif()
    endif()
else()
  set(CMAKE_CXX_STANDARD 11)
endif()

if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "-fno-exceptions ${CMAKE_CXX_FLAGS}")
endif()

set(CMAKE_AUTOMOC TRUE)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

write_basic_package_version_file(
    "${CMAKE_BINARY_DIR}/${LIBFM_QT_LIBRARY_NAME}-config-version.cmake"
    VERSION ${LIBFM_QT_LIB_VERSION}
    COMPATIBILITY AnyNewerVersion
)

install(FILES
    "${CMAKE_BINARY_DIR}/${LIBFM_QT_LIBRARY_NAME}-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${LIBFM_QT_LIBRARY_NAME}"
    COMPONENT Devel
)

add_subdirectory(src)

# add Doxygen support to generate API docs
# References:
# http://majewsky.wordpress.com/2010/08/14/tip-of-the-day-cmake-and-doxygen/
# http://www.bluequartz.net/projects/EIM_Segmentation/SoftwareDocumentation/html/usewithcmakeproject.html
option(BUILD_DOCUMENTATION "Use Doxygen to create the HTML based API documentation" OFF)
if(BUILD_DOCUMENTATION)
    find_package(Doxygen REQUIRED)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in" "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile" @ONLY)
    add_custom_target(doc ALL
        ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
        COMMENT "Generating API documentation with Doxygen" VERBATIM
    )
    install(DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}/docs"
        DESTINATION "${CMAKE_INSTALL_DOCDIR}"
        COMPONENT Devel
    )
endif()

# building tarball with CPack -------------------------------------------------
# To create a source distribution, type:
# make package_source
include(InstallRequiredSystemLibraries)
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
set(CPACK_PACKAGE_VENDOR "")
set(CPACK_PACKAGE_VERSION_MAJOR ${LIBFM_QT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${LIBFM_QT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${LIBFM_QT_VERSION_PATCH})
set(CPACK_GENERATOR TBZ2)
set(CPACK_SOURCE_GENERATOR TBZ2)
set(CPACK_SOURCE_IGNORE_FILES /build/;.gitignore;.*~;.git;.kdev4;temp)
include(CPack)

=== src/CMakeLists.txt ===
set(libfm_TRANSLATION_TEMPLATE ${PROJECT_NAME})

include_directories(
    "${LIBFM_INCLUDE_DIRS}"
    "${LIBFM_INCLUDEDIR}/libfm" # to workaround incorrect #include in fm-actions.
    "${LIBMENUCACHE_INCLUDE_DIRS}"
    "${SYSTEM_LIBS_INCLUDE_DIRS}"
)

link_directories(
    "${LIBFM_LIBRARY_DIRS}"
    "${LIBMENUCACHE_LIBRARY_DIRS}"
    "${SYSTEM_LIBS_LIBRARY_DIRS}"
)

set(libfm_SRCS
    libfmqt.cpp
    bookmarkaction.cpp
    sidepane.cpp
    icontheme.cpp
    filelauncher.cpp
    foldermodel.cpp
    foldermodelitem.cpp
    cachedfoldermodel.cpp
    proxyfoldermodel.cpp
    folderview.cpp
    folderitemdelegate.cpp
    createnewmenu.cpp
    filemenu.cpp
    foldermenu.cpp
    filepropsdialog.cpp
    applaunchcontext.cpp
    placesview.cpp
    placesmodel.cpp
    placesmodelitem.cpp
    dirtreeview.cpp
    dirtreemodel.cpp
    dirtreemodelitem.cpp
    dnddest.cpp
    mountoperation.cpp
    mountoperationpassworddialog.cpp
    mountoperationquestiondialog.cpp
    fileoperation.cpp
    fileoperationdialog.cpp
    renamedialog.cpp
    pathedit.cpp
    colorbutton.cpp
    fontbutton.cpp
    browsehistory.cpp
    utilities.cpp
    dndactionmenu.cpp
    editbookmarksdialog.cpp
    thumbnailloader.cpp
    path.cpp
    execfiledialog.cpp
    appchoosercombobox.cpp
    appmenuview.cpp
    appchooserdialog.cpp
    filesearchdialog.cpp
    fm-search.c # might be moved to libfm later
    xdndworkaround.cpp
)

set(libfm_UIS
    file-props.ui
    file-operation-dialog.ui
    rename-dialog.ui
    mount-operation-password.ui
    edit-bookmarks.ui
    exec-file.ui
    app-chooser-dialog.ui
    filesearch.ui
)

qt5_wrap_ui(libfm_UIS_H ${libfm_UIS})

# add translation for libfm-qt
lxqt_translate_ts(QM_FILES
    UPDATE_TRANSLATIONS ${UPDATE_TRANSLATIONS}
    SOURCES ${libfm_SRCS} ${libfm_UIS}
    TEMPLATE ${libfm_TRANSLATION_TEMPLATE}
)

add_library(${LIBFM_QT_LIBRARY_NAME} SHARED
    ${libfm_SRCS}
    ${libfm_UIS_H}
    ${QM_FILES}
)

set_property(
    TARGET ${LIBFM_QT_LIBRARY_NAME} APPEND
    PROPERTY COMPILE_DEFINITIONS
    LIBFM_DATA_DIR="${CMAKE_INSTALL_FULL_DATADIR}/libfm-qt"
)

# only turn on custom actions support if it is enabled in libfm.
if(EXISTS "${LIBFM_INCLUDEDIR}/libfm/fm-actions.h")
    set_property(TARGET ${LIBFM_QT_LIBRARY_NAME} APPEND PROPERTY COMPILE_DEFINITIONS CUSTOM_ACTIONS)
endif()

install(EXPORT
    "${LIBFM_QT_LIBRARY_NAME}-targets"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${LIBFM_QT_LIBRARY_NAME}"
    COMPONENT Devel
)

target_link_libraries(${LIBFM_QT_LIBRARY_NAME}
    Qt5::Widgets
    Qt5::X11Extras
    ${LIBFM_LIBRARIES}
    ${LIBMENUCACHE_LIBRARIES}
    ${SYSTEM_LIBS_LIBRARIES}
)

# set libtool soname
set_target_properties(${LIBFM_QT_LIBRARY_NAME} PROPERTIES
    VERSION ${LIBFM_QT_LIB_VERSION}
    SOVERSION ${LIBFM_QT_LIB_SOVERSION}
)

target_include_directories(${LIBFM_QT_LIBRARY_NAME}
    PRIVATE "${LIB_XCB_INDLUDE_DIRS}"
    PRIVATE "${Qt5Gui_PRIVATE_INCLUDE_DIRS}"
    INTERFACE "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/${LIBFM_QT_LIBRARY_NAME}_export.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/libfm-qt"
    COMPONENT Devel
)

# install include header files (FIXME: can we make this cleaner? should dir name be versioned?)
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/libfm-qt"
    COMPONENT Devel
    FILES_MATCHING PATTERN "*.h"
)

generate_export_header(${LIBFM_QT_LIBRARY_NAME}
    EXPORT_MACRO_NAME LIBFM_QT_API
)

configure_package_config_file(
    "${PROJECT_SOURCE_DIR}/cmake/fm-qt-config.cmake.in"
    "${PROJECT_BINARY_DIR}/install/${LIBFM_QT_LIBRARY_NAME}-config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${LIBFM_QT_LIBRARY_NAME}"
)

install(FILES
    "${PROJECT_BINARY_DIR}/install/${LIBFM_QT_LIBRARY_NAME}-config.cmake"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${LIBFM_QT_LIBRARY_NAME}"
    COMPONENT Devel
)

# FIXME: add libtool version to the lib (soname) later.
# FIXME: only export public symbols

install(TARGETS ${LIBFM_QT_LIBRARY_NAME}
    DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    EXPORT "${LIBFM_QT_LIBRARY_NAME}-targets"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    PUBLIC_HEADER
    COMPONENT Runtime
)

export(TARGETS ${LIBFM_QT_LIBRARY_NAME}
    FILE "${CMAKE_BINARY_DIR}/${LIBFM_QT_LIBRARY_NAME}-targets.cmake"
    EXPORT_LINK_INTERFACE_LIBRARIES
)

# install a pkgconfig file for libfm-qt
set(REQUIRED_QT "Qt5Widgets >= ${REQUIRED_QT_VERSION} Qt5X11Extras >= ${REQUIRED_QT_VERSION}")
configure_file(libfm-qt.pc.in lib${LIBFM_QT_LIBRARY_NAME}.pc @ONLY)
# FreeBSD loves to install files to different locations
# http://www.freebsd.org/doc/handbook/dirstructure.html
if(${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
    install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/lib${LIBFM_QT_LIBRARY_NAME}.pc"
        DESTINATION libdata/pkgconfig
        COMPONENT Devel
    )
else()
    install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/lib${LIBFM_QT_LIBRARY_NAME}.pc"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
        COMPONENT Devel
    )
endif()

install(FILES
    ${QM_FILES}
    DESTINATION "${CMAKE_INSTALL_DATADIR}/libfm-qt/translations"
    COMPONENT Runtime
)

# prevent the generated files from being deleted during make cleaner
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM true)

=== debian/changelog ===
libfm-qt (0.11.0-2build1) yakkety; urgency=medium

  * Rebuild against Qt 5.6. (uses private Qt ABI)

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Mon, 01 Aug 2016 10:59:58 +0300

libfm-qt (0.11.0-2) unstable; urgency=medium

  * Merged changes into unstable
  * Added five new symbols, leave the rest untouched
  * Removed not needed build dependency liblxqt0-dev
  * Removed not needed patches (libfm-qt contains no desktop files,
    so the desktop translation must not be patched)
  * Fixed VCS-* fields

 -- Alf Gaida <agaida@siduction.org>  Thu, 31 Mar 2016 21:38:41 +0200

libfm-qt (0.11.0-1) experimental; urgency=medium

  * New upstream release.
  * Bump soversion to 3.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 19 Mar 2016 15:51:15 +0800

libfm-qt (0.10.0+20151214-3) unstable; urgency=medium

  * Add hardening=+all
  * Bump Standards to 3.9.7
  * Fix LXQtTranlateDesktop - just in case
  * Fix year in copyrights
  * fix grep usage in cmake/LXQtTranslateDesktop.cmake - just in case

 -- Alf Gaida <agaida@siduction.org>  Thu, 25 Feb 2016 22:16:17 +0100

=== debian/control ===
--- 
+++ 
@@ -6,26 +6,30 @@
            Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>
 Section: x11
 Priority: optional
-Build-Depends: cmake (>= 3.0.2),
-               debhelper (>= 9),
+Build-Depends: debhelper (>= 9),
+               cmake (>= 3.0.2),
                libfm-dev (>= 1.2.0),
                libglib2.0-dev,
-               liblxqt0-dev (>= 0.10.0),
                libmenu-cache-dev,
                libqt5x11extras5-dev,
                libqt5xdg-dev (>= 1.3.0),
                libx11-dev,
                pkg-config,
+               qtbase5-private-dev,
                qttools5-dev,
                qttools5-dev-tools
-Standards-Version: 3.9.6
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-lxqt/libfm-qt
-Vcs-Git: https://anonscm.debian.org/pkg-lxqt/libfm-qt.git -b debian/sid
+Standards-Version: 3.9.7
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-lxqt/libfm-qt.git/?h=debian/sid
+Vcs-Git: https://anonscm.debian.org/cgit/pkg-lxqt/libfm-qt.git -b debian/sid
 Homepage: https://github.com/lxde/libfm-qt
 
-Package: libfm-qt2
-Replaces: libfm-qt5-2
-Breaks: libfm-qt5-2
+Package: libfm-qt3
+Provides: libfm-qt
+Conflicts: libfm-qt
+Replaces: libfm-qt5-2,
+          libfm-qt2
+Breaks: libfm-qt5-2,
+        libfm-qt2
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -44,7 +48,9 @@
 Architecture: any
 Section: libdevel
 Depends: ${misc:Depends},
-         ${shlibs:Depends},
-         libfm-qt2 (= ${binary:Version})
+         libfm-qt3 (= ${binary:Version})
 Description: file management support library for pcmanfm-qt (development files)
+ Libfm-Qt is a companion library providing components to build desktop file
+ managers.
+ .
  This package contains development files for helper library libfm-qt.

=== debian/rules ===
#!/usr/bin/make -f
#DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh ${@} --buildsystem cmake \
	        --parallel

## libfm-qt 0.11.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(libfm-qt)

set(LIBFM_QT_LIBRARY_NAME "fm-qt" CACHE STRING "fm-qt")

set(LIBFM_QT_VERSION_MAJOR 0)
set(LIBFM_QT_VERSION_MINOR 11)
set(LIBFM_QT_VERSION_PATCH 2)
set(LIBFM_QT_VERSION ${LIBFM_QT_VERSION_MAJOR}.${LIBFM_QT_VERSION_MINOR}.${LIBFM_QT_VERSION_PATCH})

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

# We use the libtool versioning scheme for the internal so name, "current:revision:age"
# http://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html#Updating-version-info
# https://www.sourceware.org/autobook/autobook/autobook_91.html
# http://pusling.com/blog/?p=352
# Actually, libtool uses different ways on different operating systems. So there is no
# universal way to translate a libtool version-info to a cmake version.
# We use "(current-age).age.revision" as the cmake version.
# current: 4, revision: 0, age: 1 => version: 3.1.0
set(LIBFM_QT_LIB_VERSION "3.1.0")
set(LIBFM_QT_LIB_SOVERSION "3")

set(REQUIRED_QT_VERSION "5.2")
set(REQUIRED_LIBFM_VERSION "1.2.0")
set(REQUIRED_LIBMENUCACHE_VERSION "0.4.0")
set(REQUIRED_LXQT_BUILD_TOOLS_VERSION "0.3.0")

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

find_package(Qt5Widgets "${REQUIRED_QT_VERSION}" REQUIRED)
find_package(Qt5LinguistTools "${REQUIRED_QT_VERSION}" REQUIRED)
find_package(Qt5X11Extras "${REQUIRED_QT_VERSION}" REQUIRED)

find_package(lxqt-build-tools "${REQUIRED_LXQT_BUILD_TOOLS_VERSION}" REQUIRED)
find_package(Fm "${REQUIRED_LIBFM_VERSION}" REQUIRED)
find_package(MenuCache "${REQUIRED_LIBMENUCACHE_VERSION}" REQUIRED)
find_package(XCB REQUIRED)

message(STATUS "Building ${PROJECT_NAME} with Qt ${Qt5Core_VERSION_STRING}")

option(UPDATE_TRANSLATIONS "Update source translation translations/*.ts files" OFF)
include(GNUInstallDirs)
include(GenerateExportHeader)
include(CMakePackageConfigHelpers)
include(LXQtTranslateTs)
include(LXQtTranslateDesktop)
include(LXQtCompilerSettings NO_POLICY_SCOPE)

set(CMAKE_AUTOMOC TRUE)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

write_basic_package_version_file(
    "${CMAKE_BINARY_DIR}/${LIBFM_QT_LIBRARY_NAME}-config-version.cmake"
    VERSION ${LIBFM_QT_LIB_VERSION}
    COMPATIBILITY AnyNewerVersion
)

install(FILES
    "${CMAKE_BINARY_DIR}/${LIBFM_QT_LIBRARY_NAME}-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${LIBFM_QT_LIBRARY_NAME}"
    COMPONENT Devel
)

add_subdirectory(src)

# add Doxygen support to generate API docs
# References:
# http://majewsky.wordpress.com/2010/08/14/tip-of-the-day-cmake-and-doxygen/
# http://www.bluequartz.net/projects/EIM_Segmentation/SoftwareDocumentation/html/usewithcmakeproject.html
option(BUILD_DOCUMENTATION "Use Doxygen to create the HTML based API documentation" OFF)
if(BUILD_DOCUMENTATION)
    find_package(Doxygen REQUIRED)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in" "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile" @ONLY)
    add_custom_target(doc ALL
        ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
        COMMENT "Generating API documentation with Doxygen" VERBATIM
    )
    install(DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}/docs"
        DESTINATION "${CMAKE_INSTALL_DOCDIR}"
        COMPONENT Devel
    )
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,18 +1,3 @@
-set(libfm_TRANSLATION_TEMPLATE ${PROJECT_NAME})
-
-include_directories(
-    "${LIBFM_INCLUDE_DIRS}"
-    "${LIBFM_INCLUDEDIR}/libfm" # to workaround incorrect #include in fm-actions.
-    "${LIBMENUCACHE_INCLUDE_DIRS}"
-    "${SYSTEM_LIBS_INCLUDE_DIRS}"
-)
-
-link_directories(
-    "${LIBFM_LIBRARY_DIRS}"
-    "${LIBMENUCACHE_LIBRARY_DIRS}"
-    "${SYSTEM_LIBS_LIBRARY_DIRS}"
-)
-
 set(libfm_SRCS
     libfmqt.cpp
     bookmarkaction.cpp
@@ -44,6 +29,7 @@
     fileoperationdialog.cpp
     renamedialog.cpp
     pathedit.cpp
+    pathbar.cpp
     colorbutton.cpp
     fontbutton.cpp
     browsehistory.cpp
@@ -51,7 +37,6 @@
     dndactionmenu.cpp
     editbookmarksdialog.cpp
     thumbnailloader.cpp
-    path.cpp
     execfiledialog.cpp
     appchoosercombobox.cpp
     appmenuview.cpp
@@ -74,11 +59,19 @@
 
 qt5_wrap_ui(libfm_UIS_H ${libfm_UIS})
 
+
+set(LIBFM_QT_DATA_DIR "${CMAKE_INSTALL_FULL_DATADIR}/libfm-qt")
+set(LIBFM_QT_INTREE_INCLUDE_DIR "${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/include")
+
 # add translation for libfm-qt
 lxqt_translate_ts(QM_FILES
     UPDATE_TRANSLATIONS ${UPDATE_TRANSLATIONS}
     SOURCES ${libfm_SRCS} ${libfm_UIS}
-    TEMPLATE ${libfm_TRANSLATION_TEMPLATE}
+    INSTALL_DIR "${LIBFM_QT_DATA_DIR}/translations"
+    PULL_TRANSLATIONS ${PULL_TRANSLATIONS}
+    CLEAN_TRANSLATIONS ${CLEAN_TRANSLATIONS}
+    TRANSLATIONS_REPO ${TRANSLATIONS_REPO}
+    TRANSLATIONS_REFSPEC ${TRANSLATIONS_REFSPEC}
 )
 
 add_library(${LIBFM_QT_LIBRARY_NAME} SHARED
@@ -87,15 +80,9 @@
     ${QM_FILES}
 )
 
-set_property(
-    TARGET ${LIBFM_QT_LIBRARY_NAME} APPEND
-    PROPERTY COMPILE_DEFINITIONS
-    LIBFM_DATA_DIR="${CMAKE_INSTALL_FULL_DATADIR}/libfm-qt"
-)
-
 # only turn on custom actions support if it is enabled in libfm.
-if(EXISTS "${LIBFM_INCLUDEDIR}/libfm/fm-actions.h")
-    set_property(TARGET ${LIBFM_QT_LIBRARY_NAME} APPEND PROPERTY COMPILE_DEFINITIONS CUSTOM_ACTIONS)
+if(EXISTS "${FM_INCLUDE_DIR}/libfm/fm-actions.h")
+    target_compile_definitions(${LIBFM_QT_LIBRARY_NAME} PRIVATE CUSTOM_ACTIONS)
 endif()
 
 install(EXPORT
@@ -107,9 +94,9 @@
 target_link_libraries(${LIBFM_QT_LIBRARY_NAME}
     Qt5::Widgets
     Qt5::X11Extras
-    ${LIBFM_LIBRARIES}
-    ${LIBMENUCACHE_LIBRARIES}
-    ${SYSTEM_LIBS_LIBRARIES}
+    ${FM_LIBRARIES}
+    ${MENUCACHE_LIBRARIES}
+    ${XCB_LIBRARIES}
 )
 
 # set libtool soname
@@ -119,9 +106,20 @@
 )
 
 target_include_directories(${LIBFM_QT_LIBRARY_NAME}
-    PRIVATE "${LIB_XCB_INDLUDE_DIRS}"
     PRIVATE "${Qt5Gui_PRIVATE_INCLUDE_DIRS}"
-    INTERFACE "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
+    PUBLIC
+        "${FM_INCLUDE_DIRS}"
+        "${FM_INCLUDE_DIR}/libfm" # to workaround incorrect #include in fm-actions.
+        "${MENUCACHE_INCLUDE_DIRS}"
+        "${XCB_INCLUDE_DIRS}"
+    INTERFACE
+        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
+        "$<BUILD_INTERFACE:${LIBFM_QT_INTREE_INCLUDE_DIR}>"
+)
+
+target_compile_definitions(${LIBFM_QT_LIBRARY_NAME}
+    PRIVATE "LIBFM_QT_DATA_DIR=\"${LIBFM_QT_DATA_DIR}\""
+    PUBLIC "QT_NO_KEYWORDS"
 )
 
 install(FILES
@@ -130,25 +128,31 @@
     COMPONENT Devel
 )
 
+file(GLOB libfm_HS "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
 # install include header files (FIXME: can we make this cleaner? should dir name be versioned?)
-install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/"
+install(FILES ${libfm_HS}
     DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/libfm-qt"
     COMPONENT Devel
-    FILES_MATCHING PATTERN "*.h"
 )
 
 generate_export_header(${LIBFM_QT_LIBRARY_NAME}
     EXPORT_MACRO_NAME LIBFM_QT_API
 )
 
+# InTree build
+file(COPY ${libfm_HS} ${CMAKE_CURRENT_BINARY_DIR}/${LIBFM_QT_LIBRARY_NAME}_export.h
+    DESTINATION "${LIBFM_QT_INTREE_INCLUDE_DIR}/libfm-qt"
+)
+
+
 configure_package_config_file(
     "${PROJECT_SOURCE_DIR}/cmake/fm-qt-config.cmake.in"
-    "${PROJECT_BINARY_DIR}/install/${LIBFM_QT_LIBRARY_NAME}-config.cmake"
+    "${CMAKE_BINARY_DIR}/${LIBFM_QT_LIBRARY_NAME}-config.cmake"
     INSTALL_DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${LIBFM_QT_LIBRARY_NAME}"
 )
 
 install(FILES
-    "${PROJECT_BINARY_DIR}/install/${LIBFM_QT_LIBRARY_NAME}-config.cmake"
+    "${CMAKE_BINARY_DIR}/${LIBFM_QT_LIBRARY_NAME}-config.cmake"
     DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${LIBFM_QT_LIBRARY_NAME}"
     COMPONENT Devel
 )
@@ -188,11 +192,5 @@
     )
 endif()
 
-install(FILES
-    ${QM_FILES}
-    DESTINATION "${CMAKE_INSTALL_DATADIR}/libfm-qt/translations"
-    COMPONENT Runtime
-)
-
 # prevent the generated files from being deleted during make cleaner
 set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM true)

=== debian/changelog ===
libfm-qt (0.11.2-1) unstable; urgency=medium

  * Cherry-picking upstream release 0.11.2
  * Added new symbols
  * Removed build dependencies:
    - cmake
    - liblxqt0-dev
    - libqt5xdg-dev
    - pkg-config
    - qttools5-dev
    - qttools5-dev-tools
  * Added build dependency lxqt-build-tools
  * Added build dependency libfm-dev to libfm-qt-dev
  * Removed models.patch, applied upstream

 -- Alf Gaida <agaida@siduction.org>  Thu, 22 Dec 2016 01:32:58 +0100

libfm-qt (0.11.1-3) unstable; urgency=medium

  * Backported a upstream fix for Icon Emblem Support.
  * Added needed Symbols 

 -- Alf Gaida <agaida@siduction.org>  Thu, 20 Oct 2016 18:00:38 +0200

libfm-qt (0.11.1-2) unstable; urgency=medium

  * Cherry-picking upstream release 0.11.1.
  * Syncded debian foo with experimental
  * Bump compat to 10
  * Removed --parallel from rules, standard compat 10
  * Bumped Standards to 3.9.8, no changes needed
  * Bump minimum version debhelper (>= 10)
  * Bump minimum version libqt5xdg-dev (>= 2.0.0)
  * Re-introduce build dependency liblxqt0-dev (>= 0.11.0)
  * Added build dependency libqt5svg5-dev
  * Added Recommends libfm-qt-l10n
  * Exported LC_ALL=C.UTF-8 - define language settings for reproducible
    builds 
  * Hard override translation control
  * Use DCMAKE_BUILD_TYPE=RelWithDebInfo
  * Fixed copyright Format field, using https
  * Fixed copyrights, removed obsolete files
  * Fixed libfm-qt3.install, don't install translations

 -- Alf Gaida <agaida@siduction.org>  Tue, 18 Oct 2016 01:07:52 +0200

=== debian/control ===
--- 
+++ 
@@ -6,21 +6,19 @@
            Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>
 Section: x11
 Priority: optional
-Build-Depends: debhelper (>= 9),
-               cmake (>= 3.0.2),
+Build-Depends: debhelper (>= 10),
                libfm-dev (>= 1.2.0),
                libglib2.0-dev,
+               libkf5windowsystem-dev,
                libmenu-cache-dev,
+               libqt5svg5-dev,
                libqt5x11extras5-dev,
-               libqt5xdg-dev (>= 1.3.0),
                libx11-dev,
-               pkg-config,
-               qtbase5-private-dev,
-               qttools5-dev,
-               qttools5-dev-tools
-Standards-Version: 3.9.7
+               lxqt-build-tools (>= 0.3.0),
+               qtbase5-private-dev
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-lxqt/libfm-qt.git/?h=debian/sid
-Vcs-Git: https://anonscm.debian.org/cgit/pkg-lxqt/libfm-qt.git -b debian/sid
+Vcs-Git: https://anonscm.debian.org/git/pkg-lxqt/libfm-qt.git -b debian/sid
 Homepage: https://github.com/lxde/libfm-qt
 
 Package: libfm-qt3
@@ -35,6 +33,7 @@
 Section: libs
 Depends: ${misc:Depends},
          ${shlibs:Depends}
+Recommends: libfm-qt-l10n
 Pre-Depends: ${misc:Pre-Depends}
 Description: file management support for pcmanfm-qt
  Libfm-Qt is a companion library providing components to build desktop file
@@ -48,6 +47,7 @@
 Architecture: any
 Section: libdevel
 Depends: ${misc:Depends},
+         libfm-dev (>= 1.2.0),
          libfm-qt3 (= ${binary:Version})
 Description: file management support library for pcmanfm-qt (development files)
  Libfm-Qt is a companion library providing components to build desktop file

=== debian/rules ===
#!/usr/bin/make -f
# export DH_VERBOSE = 1

export LC_ALL=C.UTF-8
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh ${@} --buildsystem cmake \
		--fail-missing

override_dh_auto_configure:
	dh_auto_configure -- \
		-DPULL_TRANSLATIONS=OFF \
		-DUPDATE_TRANSLATIONS=OFF \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo

## libfm-qt 0.12.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,8 +4,8 @@
 set(LIBFM_QT_LIBRARY_NAME "fm-qt" CACHE STRING "fm-qt")
 
 set(LIBFM_QT_VERSION_MAJOR 0)
-set(LIBFM_QT_VERSION_MINOR 11)
-set(LIBFM_QT_VERSION_PATCH 2)
+set(LIBFM_QT_VERSION_MINOR 12)
+set(LIBFM_QT_VERSION_PATCH 0)
 set(LIBFM_QT_VERSION ${LIBFM_QT_VERSION_MAJOR}.${LIBFM_QT_VERSION_MINOR}.${LIBFM_QT_VERSION_PATCH})
 
 list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
@@ -24,7 +24,7 @@
 set(REQUIRED_QT_VERSION "5.2")
 set(REQUIRED_LIBFM_VERSION "1.2.0")
 set(REQUIRED_LIBMENUCACHE_VERSION "0.4.0")
-set(REQUIRED_LXQT_BUILD_TOOLS_VERSION "0.3.0")
+set(REQUIRED_LXQT_BUILD_TOOLS_VERSION "0.4.0")
 
 if (NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE Release)
@@ -37,9 +37,10 @@
 find_package(lxqt-build-tools "${REQUIRED_LXQT_BUILD_TOOLS_VERSION}" REQUIRED)
 find_package(Fm "${REQUIRED_LIBFM_VERSION}" REQUIRED)
 find_package(MenuCache "${REQUIRED_LIBMENUCACHE_VERSION}" REQUIRED)
+find_package(Exif REQUIRED)
 find_package(XCB REQUIRED)
 
-message(STATUS "Building ${PROJECT_NAME} with Qt ${Qt5Core_VERSION_STRING}")
+message(STATUS "Building ${PROJECT_NAME} with Qt ${Qt5Core_VERSION}")
 
 option(UPDATE_TRANSLATIONS "Update source translation translations/*.ts files" OFF)
 include(GNUInstallDirs)
@@ -65,6 +66,7 @@
 )
 
 add_subdirectory(src)
+add_subdirectory(data)
 
 # add Doxygen support to generate API docs
 # References:

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,41 @@
+set(libfm_core_SRCS
+    # core data structures
+    core/gobjectptr.h
+    core/filepath.cpp
+    core/iconinfo.cpp
+    core/mimetype.cpp
+    core/fileinfo.cpp
+    core/folder.cpp
+    core/filemonitor.cpp
+    # i/o jobs
+    core/job.cpp
+    core/copyjob.cpp
+    core/deletejob.cpp
+    core/dirlistjob.cpp
+    core/filechangeattrjob.cpp
+    core/fileinfojob.cpp
+    core/filelinkjob.cpp
+    core/fileoperationjob.cpp
+    core/filesysteminfojob.cpp
+    core/job.cpp
+    core/totalsizejob.cpp
+    core/trashjob.cpp
+    core/untrashjob.cpp
+    core/thumbnailjob.cpp
+    # extra desktop services
+    core/bookmarks.cpp
+    core/volumemanager.cpp
+    core/userinfocache.cpp
+    core/thumbnailer.cpp
+    core/terminal.cpp
+    # custom actions
+    customactions/fileaction.cpp
+    customactions/fileactionprofile.cpp
+    customactions/fileactioncondition.cpp
+)
+
 set(libfm_SRCS
+    ${libfm_core_SRCS}
     libfmqt.cpp
     bookmarkaction.cpp
     sidepane.cpp
@@ -36,12 +73,12 @@
     utilities.cpp
     dndactionmenu.cpp
     editbookmarksdialog.cpp
-    thumbnailloader.cpp
     execfiledialog.cpp
     appchoosercombobox.cpp
     appmenuview.cpp
     appchooserdialog.cpp
     filesearchdialog.cpp
+    filedialog.cpp
     fm-search.c # might be moved to libfm later
     xdndworkaround.cpp
 )
@@ -55,6 +92,7 @@
     exec-file.ui
     app-chooser-dialog.ui
     filesearch.ui
+    filedialog.ui
 )
 
 qt5_wrap_ui(libfm_UIS_H ${libfm_UIS})
@@ -80,11 +118,6 @@
     ${QM_FILES}
 )
 
-# only turn on custom actions support if it is enabled in libfm.
-if(EXISTS "${FM_INCLUDE_DIR}/libfm/fm-actions.h")
-    target_compile_definitions(${LIBFM_QT_LIBRARY_NAME} PRIVATE CUSTOM_ACTIONS)
-endif()
-
 install(EXPORT
     "${LIBFM_QT_LIBRARY_NAME}-targets"
     DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${LIBFM_QT_LIBRARY_NAME}"
@@ -97,6 +130,7 @@
     ${FM_LIBRARIES}
     ${MENUCACHE_LIBRARIES}
     ${XCB_LIBRARIES}
+    ${EXIF_LIBRARIES}
 )
 
 # set libtool soname
@@ -112,6 +146,7 @@
         "${FM_INCLUDE_DIR}/libfm" # to workaround incorrect #include in fm-actions.
         "${MENUCACHE_INCLUDE_DIRS}"
         "${XCB_INCLUDE_DIRS}"
+        "${EXIF_INCLUDE_DIRS}"
     INTERFACE
         "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
         "$<BUILD_INTERFACE:${LIBFM_QT_INTREE_INCLUDE_DIR}>"
@@ -128,11 +163,11 @@
     COMPONENT Devel
 )
 
-file(GLOB libfm_HS "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
 # install include header files (FIXME: can we make this cleaner? should dir name be versioned?)
-install(FILES ${libfm_HS}
+install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
     DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/libfm-qt"
     COMPONENT Devel
+    FILES_MATCHING PATTERN "*.h"
 )
 
 generate_export_header(${LIBFM_QT_LIBRARY_NAME}
@@ -140,10 +175,14 @@
 )
 
 # InTree build
-file(COPY ${libfm_HS} ${CMAKE_CURRENT_BINARY_DIR}/${LIBFM_QT_LIBRARY_NAME}_export.h
+file(COPY ${CMAKE_CURRENT_BINARY_DIR}/${LIBFM_QT_LIBRARY_NAME}_export.h
     DESTINATION "${LIBFM_QT_INTREE_INCLUDE_DIR}/libfm-qt"
 )
 
+file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/
+    DESTINATION "${LIBFM_QT_INTREE_INCLUDE_DIR}/libfm-qt"
+    FILES_MATCHING PATTERN "*.h"
+)
 
 configure_package_config_file(
     "${PROJECT_SOURCE_DIR}/cmake/fm-qt-config.cmake.in"
@@ -194,3 +233,37 @@
 
 # prevent the generated files from being deleted during make cleaner
 set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM true)
+
+
+set(TEST_LIBRARIES
+    Qt5::Core
+    Qt5::Widgets
+    ${FM_LIBRARIES}
+    ${LIBFM_QT_LIBRARY_NAME}
+)
+# some simple test cases
+add_executable("test-folder"
+    tests/test-folder.cpp
+)
+target_link_libraries("test-folder" ${TEST_LIBRARIES})
+
+add_executable("test-folderview"
+    tests/test-folderview.cpp
+)
+target_link_libraries("test-folderview" ${TEST_LIBRARIES})
+
+add_executable("test-filedialog"
+    tests/test-filedialog.cpp
+)
+target_link_libraries("test-filedialog" ${TEST_LIBRARIES})
+
+add_executable("test-volumemanager"
+    tests/test-volumemanager.cpp
+)
+target_link_libraries("test-volumemanager" ${TEST_LIBRARIES})
+
+add_executable("test-placesview"
+    tests/test-placesview.cpp
+)
+target_link_libraries("test-placesview" ${TEST_LIBRARIES})
+

=== debian/changelog ===
libfm-qt (0.12.0-14build2) bionic; urgency=medium

  * No-change rebuild against qtbase-abi-5-9-5.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 14 Apr 2018 21:59:54 -0500

libfm-qt (0.12.0-14build1) bionic; urgency=medium

  * No-change rebuild against qtbase-abi-5-9-4.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Tue, 27 Feb 2018 09:49:15 -0600

libfm-qt (0.12.0-14) unstable; urgency=medium

  * Bumped Standards to 4.1.2, no changes needed
  * Removed branch from VCS fields
  * Removed debian/gbp.conf
  * Removed trailing whitespaces  

 -- Alf Gaida <agaida@siduction.org>  Wed, 13 Dec 2017 20:08:02 +0100

libfm-qt (0.12.0-13) unstable; urgency=medium

  * Transition to unstable

 -- Alf Gaida <agaida@siduction.org>  Mon, 04 Dec 2017 18:41:41 +0100

libfm-qt (0.12.0-12) experimental; urgency=medium

  * finally fixed the symbols for the very most architectures

 -- Alf Gaida <agaida@siduction.org>  Fri, 01 Dec 2017 20:51:49 +0100

libfm-qt (0.12.0-11) experimental; urgency=medium

  * added new symbol to mips64el
  * added and fixed a bunch of armel symbols

 -- Alf Gaida <agaida@siduction.org>  Sun, 05 Nov 2017 00:27:13 +0100

libfm-qt (0.12.0-10) experimental; urgency=medium

  * fixed symbols for mips64el

 -- Alf Gaida <agaida@siduction.org>  Sat, 04 Nov 2017 17:55:04 +0100

libfm-qt (0.12.0-9) experimental; urgency=medium

  * next round of symbols

 -- Alf Gaida <agaida@siduction.org>  Sun, 29 Oct 2017 02:59:13 +0200

libfm-qt (0.12.0-8) experimental; urgency=medium

  * introduced two optional symbols
  * fixed sh4 symbols

 -- Alf Gaida <agaida@siduction.org>  Sat, 28 Oct 2017 17:45:54 +0200

libfm-qt (0.12.0-7) experimental; urgency=medium

  * Some more symbol fixes for armel, armhf, mips, mipsel. hppa, m68k,
    ppc64 and sh4

 -- Alf Gaida <agaida@siduction.org>  Thu, 26 Oct 2017 16:30:32 +0200

libfm-qt (0.12.0-6) experimental; urgency=medium

  * Fixed symbols for arm64, ppc64el, s390x, hppa, powerpc, ppc64 and sparc64

 -- Alf Gaida <agaida@siduction.org>  Thu, 26 Oct 2017 02:56:20 +0200

libfm-qt (0.12.0-5) experimental; urgency=medium

  * Symbol fixes for i386 - this will introduce regressions for other
    architectures

 -- Alf Gaida <agaida@siduction.org>  Thu, 26 Oct 2017 00:57:28 +0200

libfm-qt (0.12.0-4) experimental; urgency=medium

  * Symbol fixes for armel, mipsel, hurd-i386, x32

 -- Alf Gaida <agaida@siduction.org>  Tue, 24 Oct 2017 23:49:03 +0200

libfm-qt (0.12.0-3) experimental; urgency=medium

  * Next round of fixed symbols

 -- Alf Gaida <agaida@siduction.org>  Mon, 23 Oct 2017 01:29:24 +0200

libfm-qt (0.12.0-2) experimental; urgency=medium

  * Fixed symbols for arm64 armhf i386 mips ppc64el alpha powerpc ppc64 sparc64

 -- Alf Gaida <agaida@siduction.org>  Sun, 22 Oct 2017 20:42:08 +0200

libfm-qt (0.12.0-1) experimental; urgency=medium

  * Cherry-picking upstream release 0.12.0.
  * Switched to experimental
  * Bumped Standards to 4.1.1
  * Fixed Symbols
  * Added build dependency libexif-dev
  * Added dependencies libexif-dev and libmenu-cache-dev to libfm-qt-dev
  * Added override for dh_missing
  * Bumped years in copyright

 -- Alf Gaida <agaida@siduction.org>  Sun, 22 Oct 2017 16:34:45 +0200

libfm-qt (0.11.2-2) unstable; urgency=medium

  * Bumped Standards to 4.0.0
  * Added dependency shared-mime-info (Closes: #866901)

 -- Alf Gaida <agaida@siduction.org>  Sun, 02 Jul 2017 23:01:43 +0200

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
 Section: x11
 Priority: optional
 Build-Depends: debhelper (>= 10),
+               libexif-dev,
                libfm-dev (>= 1.2.0),
                libglib2.0-dev,
                libkf5windowsystem-dev,
@@ -14,11 +15,11 @@
                libqt5svg5-dev,
                libqt5x11extras5-dev,
                libx11-dev,
-               lxqt-build-tools (>= 0.3.0),
+               lxqt-build-tools (>= 0.4.0),
                qtbase5-private-dev
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-lxqt/libfm-qt.git/?h=debian/sid
-Vcs-Git: https://anonscm.debian.org/git/pkg-lxqt/libfm-qt.git -b debian/sid
+Standards-Version: 4.1.2
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-lxqt/libfm-qt.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-lxqt/libfm-qt.git
 Homepage: https://github.com/lxde/libfm-qt
 
 Package: libfm-qt3
@@ -32,7 +33,8 @@
 Multi-Arch: same
 Section: libs
 Depends: ${misc:Depends},
-         ${shlibs:Depends}
+         ${shlibs:Depends},
+         shared-mime-info
 Recommends: libfm-qt-l10n
 Pre-Depends: ${misc:Pre-Depends}
 Description: file management support for pcmanfm-qt
@@ -47,8 +49,10 @@
 Architecture: any
 Section: libdevel
 Depends: ${misc:Depends},
+         libexif-dev,
          libfm-dev (>= 1.2.0),
-         libfm-qt3 (= ${binary:Version})
+         libfm-qt3 (= ${binary:Version}),
+         libmenu-cache-dev
 Description: file management support library for pcmanfm-qt (development files)
  Libfm-Qt is a companion library providing components to build desktop file
  managers.

=== debian/rules ===
--- 
+++ 
@@ -6,8 +6,10 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh ${@} --buildsystem cmake \
-		--fail-missing
+	dh ${@} --buildsystem cmake
+
+override_dh_missing:
+	dh_missing --fail-missing
 
 override_dh_auto_configure:
 	dh_auto_configure -- \

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/$/.asc/" \
    https://github.com/lxde/libfm-qt/releases .*/libfm-qt-([\d\.]+).tar.xz
